# Tamarin model for Diffie-Hellman
[![DH & WireGuard Protocol Model Verification](https://github.com/soundverification/wireguard/actions/workflows/model.yml/badge.svg?branch=sp_2023)](https://github.com/soundverification/wireguard/actions/workflows/model.yml?query=branch%3Asp_2023)
[![License: MPL 2.0](https://img.shields.io/badge/License-MPL%202.0-brightgreen.svg)](../../LICENSE)


## Files

- The `dh.spthy` file contains the Tamarin model, including the security properties and the auxiliary lemmas.


## Prerequisite

To verify our model of DH, you need **Tamarin**
which can be obtained from [its website](https://tamarin-prover.github.io).
Version 1.6.0 is known to work.

**Python2** is also required to run the oracle.



## Instructions

To verify the model with Tamarin, use the following command:

`tamarin-prover --prove dh.spthy`


## Verification with Docker
The model together with Tamarin and its dependencies are provided as a Docker image.
The image can be pulled and the Tamarin model can be verified as follows (assuming that Docker has been installed):
```
docker run -it ghcr.io/soundverification/tamarin@sha256:0d17fe1e30bbda2ec8d14e1d96a8361a18d7147d25e9e490a915a0d361c6b9e9 tamarin-prover --prove dh.spthy
```
